<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/10/2003 *
 * ===============                              Last change: 07/04/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_cats.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Add new categories and edit / delete existing    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Neue Kategorien hinzufuegen und bestehende       *
 *                     editieren / loeschen                             *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Init variable to avoid a notice
$CATS = '';

if (isPostRequestElementSet('add')) {
	// Add a new category
	$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_cats` WHERE cat='%s' LIMIT 1",
	array(postRequestElement('catname')), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 0) {
		// Category does not exists, we simply add it...
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_cats` (cat, visible, sort) VALUES ('%s','%s','%s')",
		array(postRequestElement('catname'), postRequestElement('visible'), bigintval(postRequestElement('parent') + 1)), __FILE__, __LINE__);
		$content = getMessage('CATEGORY_ADDED');
	} else {
		// Category does already exists
		$content = "<span class=\"admin_failed\">{--CATEGORY_ALREADY_EXISTS--}</span>";
	}

	// Free memory
	SQL_FREERESULT($result);

	// Display message
	loadTemplate('admin_settings_saved', false, $content);
} elseif ((isFormSent()) && (isPostRequestElementSet('id')) && (is_array(postRequestElement('id')))) {
	// Change or delete categories...
	$TEXT = '';
	foreach (postRequestElement('id') as $id => $cat) {
		// Secure ID
		$id = bigintval($id);

		// Is the entry set?
		if (!empty($cat)) {
			switch (getRequestElement('do'))
			{
				case 'edit': // Change categories
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_cats` SET cat='%s', `visible`='%s', sort=%s WHERE `id`=%s LIMIT 1",
					array(
					$cat,
					postRequestElement('vis', $id),
					postRequestElement('sort', $id),
					$id
					), __FILE__, __LINE__);
					$TEXT = getMessage('CATEGORIES_SAVED');
					break;

				case 'del': // Delete categories
					SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_cats` WHERE `id`=%s LIMIT 1",
						array($id), __FILE__, __LINE__);
					SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_user_cats` WHERE cat_id=%s",
						array($id), __FILE__, __LINE__);
					$TEXT = getMessage('CATEGORIES_DELETED');
					break;
			}
		} else {
			// Entry not saved
			$TEXT .= sprintf(getMessage('CATEGORY_NOT_SAVED'), $id);
		}
	}

	if (isset($TEXT)) {
		// Display message
		loadTemplate('admin_settings_saved', false, $TEXT);
	}
} elseif ((isPostRequestElementSet('del')) && (countPostSelection() > 0)) {
	// Delete categories
	$OUT = ''; $SW = 2;
	foreach (postRequestElement('sel') as $id => $value) {
		// Load data of category
		$result = SQL_QUERY_ESC("SELECT `cat` FROM `{?_MYSQL_PREFIX?}_cats` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
		list($cat) = SQL_FETCHROW($result);

		// Free result
		SQL_FREERESULT($result);

		// Prepare data for the row template
		$content = array(
			'sw'  => $SW,
			'id'  => $id,
			'cat' => $cat,
		);

		// Load row template and switch colors
		$OUT .= loadTemplate('admin_del_cats_row', true, $content);
		$SW = 3 - $SW;
	}

	// Load main template
	loadTemplate('admin_del_cats', false, $OUT);
} elseif ((isPostRequestElementSet('edit')) && (countPostSelection() > 0)) {
	// Edit categories
	$OUT = ''; $SW = 2;
	foreach (postRequestElement('sel') as $id => $value)
	{
		// Load data from the category
		$result = SQL_QUERY_ESC("SELECT cat, visible, sort FROM `{?_MYSQL_PREFIX?}_cats` WHERE `id`=%s LIMIT 1",
		array(bigintval($id)), __FILE__, __LINE__);
		list($cat, $vis, $sort) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Prepare data for the row template
		$content = array(
			'sw'   => $SW,
			'id'   => $id,
			'cat'  => $cat,
			'vis'  => addSelectionBox('yn', $vis, 'vis', $id),
			'sort' => $sort,
		);

		// Load row template and switch colors
		$OUT .= loadTemplate('admin_edit_cats_row', true, $content);
		$SW = 3 - $SW;
	}

	// Load main template
	loadTemplate('admin_edit_cats', false, $OUT);
} else {
	// Init variable here
	$CATS = '';

	// Load all categories
	$result = SQL_QUERY("SELECT `id`, `cat`, `visible`, `sort` FROM `{?_MYSQL_PREFIX?}_cats` ORDER BY `sort` ASC", __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// Init variables
		$OUT = ''; $SW = 2;

		// List already existing categories for editing
		while ($content = SQL_FETCHARRAY($result)) {
			// Prepare data for the row template
			$content['sw']  = $SW;
			$content['vis'] = translateYesNo($content['visible']);

			// Put cat descriptions into variable for the selection box
			if (strlen($content['cat']) > 20) $content['cat'] = substr($content['cat'], 0, 17)."...";
			$CATS .= "      <option value=\"".$content['sort']."\">".$content['cat']."</option>\n";

			// Load row template and switch color
			$OUT .= loadTemplate('admin_config_cats_row', true, $content);
			$SW = 3 - $SW;
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// Load main template
		loadTemplate('admin_config_cats', false, $OUT);
	} // END - if

	// Remember in array
	$content['cats'] = $CATS;

	// Form to add a new category
	loadTemplate('admin_add_cat', false, $content);
}

// [EOF]
?>
